"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Returns all the distinct values of an array
 * @memberof Array.prototype
 * @function distinct
 * @param {String|Function} [fn]
 * @returns {Array}
 * @example
 * [1, 2, 2, 3, 4, 4, 5].distinct(); // [1,2,3,4,5]
 * [{foo:{bar:[0,1]}}, {foo:{bar:[4,1]}}].distinct("foo.bar[1]"); // [{foo:{bar:[0,1]}}]
 * [1, 2, 2.2, 3, 4.9, 4, 5].distinct(Math.floor); // [1,2,3,4.9,5]
 */
utils_1.addPrototype(Array, "distinct", method_1.default);