"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * sorts the array
 * @memberof Array.prototype
 * @function orderBy
 * @param {String} [field]
 * @param {"asc"|"desc"} [order="asc"]
 * @returns {Array}
 * @example
 * [2, 1, 2, 5].orderBy(); // [1,2,2,5]
 * [2, 1, 2, 5].orderBy("desc"); // [5,2,2,1]
 * [{count:1}, {count:20}, {count:15}].orderBy("count", "asc"); // [{count:1},{count:15},{count:20}]
 */
utils_1.addPrototype(Array, "orderBy", method_1.default);