"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Groups the elements of an array based on the given function and
 * returns the count of elements in each group
 * @memberof Array.prototype
 * @function sortBy
 * @param {String|Function} fn
 * @returns {Array}
 * @example
 * ['five', 'three', 'one'].sortBy('length'); // ['one', 'five', 'three']
 * ['five', 'three', 'one'].sortBy((value) => -value.length); // ['three', 'five', 'one']
 */
utils_1.addPrototype(Array, "sortBy", method_1.default);