"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Converts a 2D array to a comma-separated values (CSV) string
 * @memberof Array.prototype
 * @function delimiter
 * @param {String} [delimiter=","]
 * @returns {String}
 * @example
 * [['a', 'b'], ['c', 'd']].toCSV(); // '"a","b"\n"c","d"'
 * [['a', 'b'], ['c', 'd']].toCSV(';'); // '"a";"b"\n"c";"d"'
 */
utils_1.addPrototype(Array, "toCSV", method_1.default);