"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Filters the array
 * @memberof Array.prototype
 * @function where
 * @param {String|*} field
 * @param {String|*} [operator]
 * @param {*} [value]
 * @returns {Array}
 * @example
 * [1, 2, 2, 3, 4, 4, 5].where(4); // [4,4]
 * [{count:1}, {count:20}, {count:15}].where("count", 15); // [{count:15}]
 * [1, 2, 2, 3, 4, 4, 5].where("<", 4); // [1,2,2,3]
 * [{count:1}, {count:20}, {count:15}].where("count", ">=", 15); // [{count:20},{count:15}]
 */
utils_1.addPrototype(Array, "where", method_1.default);