"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { "default": mod };
};
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("../contains/method"));
var OPERATORS = ["<" /* LT */
, "<=" /* LTE */
, "=" /* EQ */
, "<>" /* NE */
, ">=" /* GTE */
, ">" /* GT */
];
var method = function method(arr, field, operator, value) {
    if (operator === undefined) {
        value = field;
        field = undefined;
        operator = "=" /* EQ */;
    } else if (value === undefined) {
        if (!method_1.default(OPERATORS, field)) {
            value = operator;
            operator = "=" /* EQ */;
        } else {
            value = operator;
            operator = field;
            field = undefined;
        }
    }
    var iterator = void 0;
    switch (operator) {
        case "<" /* LT */:
            iterator = function iterator(item) {
                return item < value;
            };
            break;
        case "<=" /* LTE */:
            iterator = function iterator(item) {
                return item <= value;
            };
            break;
        case "=" /* EQ */:
            iterator = function iterator(item) {
                return item === value;
            };
            break;
        case "<>" /* NE */:
            iterator = function iterator(item) {
                return item !== value;
            };
            break;
        case ">=" /* GTE */:
            iterator = function iterator(item) {
                return item >= value;
            };
            break;
        case ">" /* GT */:
            iterator = function iterator(item) {
                return item > value;
            };
            break;
        default:
            throw new TypeError("Expected 'operator' to be one of " + OPERATORS + ", got " + operator);
    }
    return utils_1.filter(arr, field, iterator);
};
module.exports = method;