"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
    return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var method_1 = __importDefault(require("./method"));
/**
 * Returns the cached function results if already runned with this method
 * @memberof Function
 * @function cache
 * @param {Array} args
 * @returns {*}
 * @example
 * const test = () => setTimeout(console.log, 1000, `test`);
 * test.cache(); // takes a second to log 'test'
 * test.cache(); // instantly logs the second 'test'
 */
Function.prototype.cache = function cache() {
    return method_1.default(this).apply(undefined, arguments);
};