"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Ensures a function is called only once
 * @memberof Function.prototype
 * @function once
 * @param {Array} args
 * @returns {*}
 * @example
 * const test = (msg) => console.log(msg);
 * test.once('a'); // logs 'a'
 * test.once('b'); // no log this time
 */
utils_1.addPrototype(Function, "once", method_1.default);