"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Creates a new object from the specified object, where all the keys are in kebab-case
 * @memberof Object.prototype
 * @function $kebabCaseKeys
 * @returns {Object}
 * @example
 * const myObj = { First_name: "Adam", lastName: "Smith" };
 * const myObjLower = myObj.$kebabCaseKeys(); // {first-name: "Adam", last-name: "Smith"}
 */
utils_1.addPrototype(Object, "$kebabCaseKeys", method_1.default);