"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Creates an object with keys generated by running the provided function for each key
 * and the same values as the provided object
 * @memberof Object.prototype
 * @function $mapKeys
 * @param {Function} fn
 * @returns {Object}
 * @example
 * ({ a: 1, b: 2 }).$mapKeys((val, key) => key + val); // { a1: 1, b2: 2 }
 */
utils_1.addPrototype(Object, "$mapKeys", method_1.default);