"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Omits the key-value pairs corresponding to the given keys from an object; or
 * Creates an object composed of the properties the given function returns falsey for.
 * The function is invoked with two arguments: (value, key)
 * @memberof Object.prototype
 * @function $omit
 * @param {String[]|Function} arr
 * @returns {Object}
 * @example
 * { a: 1, b: '2', c: 3 }.$omit(['b']); // { a: 1, c: 3 }
 * { a: 1, b: '2', c: 3 }.$omit((x) => typeof x === 'number'); // { b: '2' }
 */
utils_1.addPrototype(Object, "$omit", method_1.default);