"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Puts the property value indicated by the given selector into the object
 * @memberof Object.prototype
 * @function $set
 * @param {String} path
 * @param {*} value
 * @example
 * const obj = { selector: { to: { val: 'val to select' } } };
 * obj.$set('selector.to.val');
 * // obj -> { selector: { to: { val: 'val to select' } } }
 */
utils_1.addPrototype(Object, "$set", method_1.default);