"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable: max-line-length
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Converts a string to kebab case
 * @memberof String.prototype
 * @function kebabCase
 * @returns {String}
 * @example
 * "camelCase".kebabCase(); // "camel-case"
 * "some text".kebabCase(); // "some-text"
 * "some-mixed_string With spaces_underscores-and-hyphens".kebabCase();
 * // "some-mixed-string-with-spaces-underscores-and-hyphens"
 * "AllThe-small Things".kebabCase(); // "all-the-small-things"
 * "IAmListeningToFMWhileLoadingDifferentURLOnMyBrowserAndAlsoEditingSomeXMLAndHTML".kebabCase();
 * // "i-am-listening-to-fm-while-loading-different-url-on-my-browser-and-also-editing-some-xml-and-html"
 */
utils_1.addPrototype(String, "kebabCase", method_1.default);