"use strict";

var __importDefault = undefined && undefined.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var method_1 = __importDefault(require("./method"));
/**
 * Replaces all but the last num of characters with the specified mask character
 * @memberof String.prototype
 * @function mask
 * @param {Number} [num=4]
 * @param {String} [mask='*']
 * @returns {String}
 * @example
 * '1234567890'.mask(); // '******7890'
 * '1234567890'.mask(3); // '*******890'
 * '1234567890'.mask(-4, '$'); // '$$$$567890'
 */
utils_1.addPrototype(String, "mask", method_1.default);