"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Returns `true` if the provided predicate function
 * returns `true` for all elements in a collection,`false` otherwise
 * @memberof Array.prototype
 * @function all
 * @param {Function} [fn=Boolean]
 * @returns {Boolean}
 * @example
 * [4, 2, 3].all((x) => x > 1); // true
 * [1, 2, 3].all(); // true
 */
utils_1.addPrototype(Array, "all", method_1.default);
