"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Returns `true` if the provided predicate function
 * returns `true` for at least one element in a collection,
 * `false` otherwise
 * @memberof Array.prototype
 * @function any
 * @param {Function} [fn=Boolean]
 * @returns {Boolean}
 * @example
 * [0, 1, 2, 0].any((x) => x >= 2); // true
 * [0, 0, 1, 0].any(); // true
 */
utils_1.addPrototype(Array, "any", method_1.default);
