"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Returns the average value of a given path
 * @memberof Array.prototype
 * @function average
 * @param {String} [path]
 * @returns {Number}
 * @example
 * [1, 2, 3].average(); // 2
 * [{a: 1}, {a: 2}, {a: 3}].average("a"); // 2
 * [{a: {b: 1}}, {a: {b: 2}}, {a: {b: 3}}].average("a.b"); // 2
 */
utils_1.addPrototype(Array, "average", method_1.default);
/**
 * An alias of Array.prototype.average
 * @memberof Array.prototype
 * @function avg
 * @param {String} [path]
 * @returns {Number}
 * @example
 * [1, 2, 3].avg(); // 2
 * [{a: 1}, {a: 2}, {a: 3}].avg("a"); // 2
 * [{a: {b: 1}}, {a: {b: 2}}, {a: {b: 3}}].avg("a.b"); // 2
 */
Array.prototype.avg = Array.prototype.average;
