"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Groups the elements of an array based on the given function and
 * returns the count of elements in each group
 * @memberof Array.prototype
 * @function countBy
 * @param {String|Function} fn
 * @returns {Object}
 * @example
 * [6.1, 4.2, 6.3].countBy(Math.floor); // {4: 1, 6: 2}
 * ['one', 'two', 'three'].countBy('length'); // {3: 2, 5: 1}
 */
utils_1.addPrototype(Array, "countBy", method_1.default);
