"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Cross joins the array's values among the given arrays,
 * returning a Cartesian product with all possible permutations
 * @memberof Array.prototype
 * @function crossJoin
 * @param {Array} array
 * @returns {Array[]}
 * @example
 * [1, 2].crossJoin(['a', 'b']); // [[1, 'a'], [1, 'b'], [2, 'a'], [2, 'b']]
 */
utils_1.addPrototype(Array, "crossJoin", method_1.default);
