"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Groups the elements of an array based on the given function
 * @memberof Array.prototype
 * @function groupBy
 * @param {String|Function} fn
 * @returns {Object}
 * @example
 * [6.1, 4.2, 6.3].groupBy(Math.floor); // {4: [4.2], 6: [6.1, 6.3]}
 * ['one', 'two', 'three'].groupBy('length'); // {3: ['one', 'two'], 5: ['three']}
 */
utils_1.addPrototype(Array, "groupBy", method_1.default);
