"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Given a flat array of objects linked to one another, it will nest them recursively
 * @memberof Array.prototype
 * @function nest
 * @param {String} link
 * @param {String} key
 * @returns {Object[]}
 * @example
 * const comments = [
 *   { id: 1, comment_id: null },
 *   { id: 2, comment_id: 1 },
 *   { id: 3, comment_id: 1 },
 *   { id: 4, comment_id: 2 },
 *   { id: 5, comment_id: 4 }
 * ];
 * comments.nest("comment_id"); // [{ id: 1, comment_id: null, children: [...] }]
 */
utils_1.addPrototype(Array, "nest", method_1.default);
