"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Groups the elements into two arrays,
 * depending on the provided function's truthiness for each element
 * @memberof Array.prototype
 * @function partition
 * @param {Function} fn
 * @returns {Array}
 * @example
 * const users = [
 *   { user: 'barney', age: 36, active: false }, { user: 'fred', age: 40, active: true }
 * ];
 * users.partition(o => o.active); // [
 *   [{ 'user': 'fred',    'age': 40, 'active': true }],
 *   [{ 'user': 'barney',  'age': 36, 'active': false }]
 * ]
 */
utils_1.addPrototype(Array, "partition", method_1.default);
