"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("../contains/method"));
const OPERATORS = [
    "<" /* LT */,
    "<=" /* LTE */,
    "=" /* EQ */,
    "<>" /* NE */,
    ">=" /* GTE */,
    ">" /* GT */,
];
const method = (arr, field, operator, value) => {
    if (operator === undefined) {
        value = field;
        field = undefined;
        operator = "=" /* EQ */;
    }
    else if (value === undefined) {
        if (!method_1.default(OPERATORS, field)) {
            value = operator;
            operator = "=" /* EQ */;
        }
        else {
            value = operator;
            operator = field;
            field = undefined;
        }
    }
    let iterator;
    switch (operator) {
        case "<" /* LT */:
            iterator = item => item < value;
            break;
        case "<=" /* LTE */:
            iterator = item => item <= value;
            break;
        case "=" /* EQ */:
            iterator = item => item === value;
            break;
        case "<>" /* NE */:
            iterator = item => item !== value;
            break;
        case ">=" /* GTE */:
            iterator = item => item >= value;
            break;
        case ">" /* GT */:
            iterator = item => item > value;
            break;
        default:
            throw new TypeError(`Expected 'operator' to be one of ${OPERATORS}, got ${operator}`);
    }
    return utils_1.filter(arr, field, iterator);
};
module.exports = method;
