"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Filters the array
 * @memberof Array.prototype
 * @function whereLike
 * @param {String|RegExp} field
 * @param {String|RegExp} [value]
 * @returns {Array}
 * @example
 * ["foo", "bar", "hello", "world"].whereLike("o"); // ["foo","hello","world"]
 * [{foo:"hello"}, {foo:"bar"}, {foo:"world"}]
 *   .whereLike("foo", /o/i); // [{foo:"hello"},{foo:"world"}]
 */
utils_1.addPrototype(Array, "whereLike", method_1.default);
