"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Given an array of valid property identifiers and an array of values,
 * return an object associating the properties to the values
 * @memberof Array.prototype
 * @function zipObject
 * @param {Array} array
 * @returns {Object}
 * @example
 * ['a', 'b', 'c'].zipObject([1, 2]); // {a: 1, b: 2, c: undefined}
 * ['a', 'b'].zipObject([1, 2, 3]); // {a: 1, b: 2}
 */
utils_1.addPrototype(Array, "zipObject", method_1.default);
