"use strict";
// tslint:disable-next-line:ban-types
const method = (func) => {
    const cache = func.cached || new Map();
    const cached = (...args) => {
        const key = JSON.stringify(args);
        return cache.has(key)
            ? cache.get(key)
            : cache.set(key, func.call(func, ...args)) && cache.get(key);
    };
    func.cached = cache;
    return cached;
};
module.exports = method;
