"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Creates an object with keys and values
 * generated by running the provided function for each value
 * @memberof Object.prototype
 * @function $map
 * @param {Function} fn
 * @returns {Object}
 * @example
 * const users = {
 *   fred: { user: "fred", age: 40 },
 *   pebbles: { user: "pebbles", age: 1 }
 * };
 * users.$map(u => u.age); // { fred: 40, pebbles: 1 }
 */
utils_1.addPrototype(Object, "$map", method_1.default);
