"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Creates a new object from the specified object, where all the keys are in snake-case
 * @memberof Object.prototype
 * @function $snakeCaseKeys
 * @returns {Object}
 * @example
 * const myObj = { FirstName: "Adam", "last-name": "Smith" };
 * const myObjLower = myObj.$snakeCaseKeys(); // {first_name: "Adam", last_name: "Smith"}
 */
utils_1.addPrototype(Object, "$snakeCaseKeys", method_1.default);
