"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Converts the string to camelcase
 * @memberof String.prototype
 * @function camelCase
 * @returns {String}
 * @example
 * "some_database_field_name".camelCase(); // "someDatabaseFieldName"
 * "Some label that needs to be camelized".camelCase(); // "someLabelThatNeedsToBeCamelized"
 * "some-javascript-property".camelCase(); // "someJavascriptProperty"
 * "some-mixed_string with spaces_underscores-and-hyphens".camelCase();
 * // "someMixedStringWithSpacesUnderscoresAndHyphens"
 */
utils_1.addPrototype(String, "camelCase", method_1.default);
