"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Converts an underscored, camelized, or dasherized string into a humanized one.
 * Also removes beginning and ending whitespace
 * @memberof String.prototype
 * @function humanize
 * @returns {String}
 * @example
 * '  capitalize dash-CamelCase_underscore trim  '.humanize();
 * // 'Capitalize dash camel case underscore trim'
 */
utils_1.addPrototype(String, "humanize", method_1.default);
