"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const method_1 = __importDefault(require("./method"));
/**
 * Returns the singular or plural form of the word based on the input number
 * @memberof String.prototype
 * @function pluralize
 * @param {Number} [count]
 * @returns {String}
 * @example
 * 'apple'.pluralize(); // 'apples'
 * 'apple'.pluralize(0); // 'apples'
 * 'apple'.pluralize(1); // 'apple'
 * 'apple'.pluralize(2); // 'apples'
 * 'person'.pluralize(2); // 'people'
 * 'people'.pluralize(1); // 'person'
 */
utils_1.addPrototype(String, "pluralize", method_1.default);
